/*

    File: file_bz2.c

    Copyright (C) 1998-2005 Christophe GRENIER <grenier@cgsecurity.org>
  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the imbz2ied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#include "types.h"
#include "photorec.h"

static int header_check_bz2(const unsigned char *buffer, const unsigned int buffer_size);
const t_file_hint file_hint_bz2= {
  .extension="bz2",
  .description="bzip2 compressed data",
  .min_header_distance=0,
  .min_filesize=0,
  .max_filesize=PHOTOREC_MAX_FILE_SIZE,
  .stream=0,
  .recover=1,
  .header_check=&header_check_bz2,
  .data_check=NULL,
  .file_check=NULL
};

static int header_check_bz2(const unsigned char *buffer, const unsigned int buffer_size)
{
  return (buffer[0]=='B' && buffer[1]=='Z' && buffer[2]=='h' && buffer[3]>47);
}
