/*

    File: file_tiff.c

    Copyright (C) 1998-2005 Christophe GRENIER <grenier@cgsecurity.org>
  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#include "types.h"
#include "photorec.h"

static int header_check_tiff(const unsigned char *buffer, const unsigned int buffer_size);
const t_file_hint file_hint_tiff= {
  .extension="tif",
  .description="Tag Image File Format",
  .min_header_distance=0,
  .min_filesize=0,
  .max_filesize=200000000,
  .stream=0,
  .recover=1,
  .header_check=&header_check_tiff,
  .data_check=NULL,
  .file_check=NULL
};

static int header_check_tiff(const unsigned char *buffer, const unsigned int buffer_size)
{
  const unsigned char tiff_header_be[4]= { 'M','M',0x00, 0x2a};
  const unsigned char tiff_header_le[4]= { 'I','I',0x2a, 0x00};
  return (memcmp(buffer,tiff_header_be,sizeof(tiff_header_be))==0 ||
      memcmp(buffer,tiff_header_le,sizeof(tiff_header_le))==0);
}
